/******************************************************************************
 * This file is part of dOpenCL.
 * 
 * dOpenCL is an implementation of the OpenCL application programming
 * interface for distributed systems. See <http://dopencl.uni-muenster.de/>
 * for more information.
 * 
 * Developed by: Research Group Parallel and Distributed Systems
 *               Department of Mathematics and Computer Science
 *               University of Muenster, Germany
 *               <http://pvs.uni-muenster.de/>
 * 
 * Copyright (C) 2013  Philipp Kegel <philipp.kegel@uni-muenster.de>
 *
 * dOpenCL is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * dOpenCL is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with dOpenCL. If not, see <http://www.gnu.org/licenses/>.
 * 
 * Permission to use dOpenCL for scientific, non-commercial work is
 * granted under the terms of the dOpenCL Academic License provided
 * appropriate credit is given. See the dOpenCL Academic License for
 * more details.
 * 
 * You should have received a copy of the dOpenCL Academic License
 * along with dOpenCL. If not, see <http://dopencl.uni-muenster.de/>.
 ******************************************************************************/

/**
 * @file    DeleteMemory.h
 *
 * @date    12.07.2012
 * @author  Philipp Kegel
 */

#ifndef DELETEMEMORY_H_
#define DELETEMEMORY_H_

#include <dcl/DCLTypes.h>

#include "Request.h"

namespace dcl {

namespace comm {

//template<GCFTypeID_t TypeId>
//class ReleaseObject: public Request {
//public:
//	ReleaseObject(dcl_object_id /* objectId */);
//	ReleaseObject(const ReleaseObject&);
//	virtual ~ReleaseObject();
//
//	dcl_object_id objectId() const { return _objectId; }
//
//	DECLARE_SERIALIZABLE_PUBLIC(ReleaseObject, TypeId)
//
//private:
//	dcl_object_id _objectId;
//
//	DECLARE_SERIALIZABLE_EVENT_PRIVATE(ReleaseObject)
//};
//
//typedef ReleaseObject<100 + Request::RELEASE_CONTEXT> ReleaseContext;
//typedef ReleaseObject<100 + Request::RELEASE_COMMAND_QUEUE> ReleaseCommandQueue;
//typedef ReleaseObject<100 + Request::RELEASE_MEM_OBJECT> ReleaseMemObject;
//typedef ReleaseObject<100 + Request::RELEASE_PROGRAM> ReleaseProgram;
//typedef ReleaseObject<100 + Request::RELEASE_KERNEL> ReleaseKernel;

/******************************************************************************/

class DeleteMemory: public Request  {
public:
	DeleteMemory(dcl_object_id /* memObjectId */);
	DeleteMemory(const DeleteMemory&);
	virtual ~DeleteMemory();

	dcl_object_id memObjectId() const { return _memObjectId; }

	DECLARE_SERIALIZABLE_PUBLIC(DeleteMemory, 100 + RELEASE_MEM_OBJECT)

private:
	dcl_object_id _memObjectId;

	DECLARE_SERIALIZABLE_EVENT_PRIVATE(DeleteMemory)
};

} /* namespace comm */

} /* namespace dcl */

#endif /* DELETEMEMORY_H_ */
